<template>
	<div class="flex-col md:rounded-lg lg:rounded bg-white px-4 md:px-6 lg:px-10 py-6 lg:py-10 mb-2">
		<div class="flex justify-between items-start md:items-center mb-6">
			<MkStepProgress
				:step-title="showLogin ? 'Sign in' : 'Enter email'"
				:step-number="stepNumber"
				:class-active="stepsCompleted == 1 ? 'active' : ''"
			/>
			<div class="font-primary-font-light flex md:block flex-col text-right">
				{{ showLogin ? 'New customer?' : 'Have an account?' }}
				<a
					tabindex="0"
					role="button"
					:aria-label="showLogin ? `Checkout` : `Sign in`"
					class="font-primary-font-bold ml-1 cursor-pointer mk-link"
					@click="userAction()"
					@keypress.enter="userAction()"
					>{{ showLogin ? 'Checkout' : 'Sign in' }}</a
				>
			</div>
		</div>
		<ValidationObserver ref="email_info_validation_observer">
			<div v-if="FEATURE_GIFT" class="flex w-full mb-4">
				<MkCheck :checked="GIFT" radio-title="This is a gift" class="mr-3" @change="gifted" />
				<MkGiftIcon />
			</div>
			<div></div>
			<div>
				<p v-if="showLogin" class="mb-6">Welcome back.</p>
				<p v-else-if="!isUserExists && !isEurope">
					Creating an account makes managing your filter auto-refills easier.
				</p>
			</div>
			<MkSuccessMessage v-if="USER_EXIST && !showLogin" class="my-4" @signIn="showLogin = true" />
			<MkErrorMessage v-if="warning" role="alert" class="my-4" />
			<MkInput
				name="Email"
				:set-focus="setFocus"
				rules="required|email"
				:value="value['email']"
				class="mb-4 mt-6"
				variant="outline"
				label="Email"
				:loading="checkingStatus"
				:disable-input="checkingStatus"
				@input="
					updateForm('email', $event);
					isUserExists = false;
				"
			/>
			<MkInput
				v-if="showLogin"
				name="Password"
				rules="required"
				:value="value['password']"
				class="mb-4"
				variant="outline"
				label="Password"
				:type="'password'"
				@input="updateForm('password', $event)"
			/>
			<div v-if="showLogin" class="my-4">
				<a
					tabindex="0"
					aria-label="I forgot my password"
					href="/D2C/login/passwordReset"
					class="font-primary-font-bold my-4 mk-link"
					>I forgot my password</a
				>
			</div>
			<div v-if="!showLogin && !isEurope" class="flex mb-6 md:mb-0 lg:mb-0">
				<MkCheck
					:checked="value['accepted']"
					class="mb-4"
					:aria-label="`Accept our terms of service ${comma} privacy policy ${!GIFT ? 'and auto-refill term' : ''} `"
					@change="accepted"
				/>
				<span>
					<span class="font-primary-font-light">Accept our</span>
					<strong>
						<nuxt-link class="mk-link" to="/legal#terms" target="_blank"> terms of service </nuxt-link>
					</strong>

					<span>{{ comma }}</span>
					<strong>
						<nuxt-link class="mk-link" to="/legal#privacy" target="_blank"> privacy policy </nuxt-link>
					</strong>
					<span v-if="!GIFT" class="font-primary-font-light">and </span>
					<strong>
						<nuxt-link v-if="!GIFT" class="mk-link" to="/legal#AutoRefills" target="_blank">
							auto-refill terms.
						</nuxt-link>
					</strong>
				</span>
			</div>
			<div v-if="!showLogin && isEurope" class="mt-7 mb-8 md:mb-10">
				<div class="flex mb-6 md:mb-0 lg:mb-6">
					<MkCheck
						:checked="value['acceptedUK']"
						class="mb-4"
						aria-label="Accept our terms of service and privacy policy. Molekule is based in the U.S., so the personal data you provide will be transferred to the U.S. Learn more in our Privacy Policy."
						@change="acceptedCheck"
					/>
					<span>
						<span class="font-primary-font-light">Accept our </span>
						<strong>
							<nuxt-link class="mk-link" to="/legal#terms" target="_blank"> terms of service </nuxt-link>
						</strong>
						<span class="font-primary-font-light">and </span>
						<strong>
							<nuxt-link class="mk-link" to="/legal#privacy" target="_blank"> privacy policy. </nuxt-link>
						</strong>
						<span class="font-primary-font-light">
							Molekule is based in the U.S., so the personal data you provide will be transferred to the U.S. Learn more
							in our Privacy Policy.</span
						>
					</span>
				</div>
				<div class="flex mb-6 md:mb-0 lg:mb-0">
					<MkCheck
						:checked="value['acceptedNewsUK']"
						class="mb-4"
						aria-label="Receive product news & exclusive offers. You can unsubscribe at any time - please see our privacy policy for details."
						@change="acceptedCheckNews"
					/>
					<span>
						<span class="font-primary-font-light"
							>Receive product news & exclusive offers. You can unsubscribe at any time - please see our</span
						>
						<strong>
							<nuxt-link class="mk-link" to="/legal#privacy" target="_blank"> privacy policy </nuxt-link>
						</strong>
						<span class="font-primary-font-light"> for details.</span>
					</span>
				</div>
			</div>
			<div class="flex justify-center items-center">
				<MkPrimaryButton
					v-if="!isEurope"
					btn-class="min-w-150 py-2 h-10 font-primary-font-regular text-xl"
					:loading="submitProcess"
					:disabled="!showLogin ? !value['accepted'] : !value['email'] || !value['password']"
					button-title="Next"
					font-size="text-xl"
					@click="completedstep()"
				/>
				<MkPrimaryButton
					v-if="isEurope"
					btn-class="min-w-150 py-2 h-10 font-primary-font-regular text-xl mb-4"
					:loading="submitProcess"
					:disabled="!showLogin ? !value['acceptedUK'] : !value['email'] || !value['password']"
					button-title="Next"
					font-size="text-xl"
					@click="completedstep()"
				/>
			</div>
		</ValidationObserver>
	</div>
</template>
<script>
import { ValidationObserver } from 'vee-validate';
import { mapState } from 'vuex';
import MkStepProgress from '~/components/D2C/atoms/MkStepProgress.vue';
import MkInput from '~/components/D2C/atoms/MkInput.vue';
import MkCheck from '~/components/D2C/atoms/MkCheck.vue';
import MkGiftIcon from '~/components/D2C/atoms/MkGiftIcon.vue';
import MkPrimaryButton from '~/components/D2C/atoms/MkPrimaryButton.vue';
import MkSuccessMessage from '~/components/D2C/atoms/MkSuccessMessage.vue';
import MkErrorMessage from '~/components/D2C/atoms/MkErrorMessage.vue';
export default {
	name: 'MkCheckoutEmail',
	components: {
		MkStepProgress,
		MkInput,
		MkCheck,
		MkGiftIcon,
		MkPrimaryButton,
		MkSuccessMessage,
		MkErrorMessage,
		ValidationObserver,
	},
	props: {
		stepsCompleted: {
			type: Number,
			default: 1,
		},
		value: {
			type: Object,
			default: () => {},
		},
		setFocus: {
			type: String,
			default: 'false',
		},
	},
	data() {
		return {
			warning: false,
			submitProcess: false,
			stepNumber: 1,
			emailExists: false,
			showLogin: false,
			formData: {},
			loginCount: 0,
			comma: ',',
			waitInterval: 1000,
			timer: null,
			isUserExists: false,
			checkingStatus: false,
		};
	},
	computed: {
		...mapState('CHECKOUT_STORE', ['FEATURE_GIFT']),
		...mapState('CART_STORE', ['CART', 'GIFT']),
		...mapState(['isEurope']),
		...mapState('USER_STORE', ['USER_EXIST']),
	},
	mounted() {
		this.updateMessage(this.GIFT);
	},
	methods: {
		async completedstep() {
			try {
				const isValidForm = await this.$refs.email_info_validation_observer.validate();
				if (!this.showLogin && isValidForm) {
					this.submitProcess = true;
					const $email = this.value.email;
					await this.$store.dispatch('CART_STORE/UPDATE_CART_ACTION', {
						action: 'SET_EMAIL',
						email: $email,
					});
					this.$store.dispatch('CART_STORE/IS_GUEST_USER', true);
					this.$emit('completedstep', this.value);
					return;
				}
				if (!isValidForm) {
					return;
				}
				this.submitProcess = true;
				this.warning = false;
				const isSuccesful = await this.$store.dispatch('USER_STORE/SIGN_IN', this.formData);
				if (isSuccesful === 'pass') {
					this.$store.commit('USER_STORE/RESET_COG_FORMS');
					this.emailExists = true;
					this.$emit('completedstep', this.value);
					if (this.CART && this.CART.anonymousId) {
						await this.$store.dispatch('CART_STORE/MERGE_CART');
						this.$store.dispatch('MK_CART_STORE/TOGGLE_SIDE_CART', 'MK_SIDE_CART');
					}
					this.warning = false;
				} else if (['login fails', 'locked', 'invalid credentials'].includes(isSuccesful)) {
					this.loginCount++;
					if (this.loginCount === 4) {
						await this.$store.dispatch('USER_STORE/CHECK_USER_EXISTS', this.formData);
					}
					if (isSuccesful === 'locked') {
						this.$store.commit('USER_STORE/SET_SIGN_IN_ERROR', {
							message: 'There have been too many failed login attempts. To access your account, reset your password.',
						});
						this.loginCount = 0;
						this.formData = {};
						this.$refs.email_info_validation_observer.reset();
					}
					if (isSuccesful === 'invalid credentials') {
						this.$store.commit('USER_STORE/SET_SIGN_IN_ERROR', {
							message: 'Incorrect username or password.',
						});
						this.formData = {};
						this.$refs.email_info_validation_observer.reset();
					}
					this.warning = true;
				}
				this.submitProcess = false;
			} catch (error) {
				this.warning = true;
				this.submitProcess = false;
			}
		},
		updateForm(fieldName, value) {
			this.checkUserIfExists(value);
			this.formData[fieldName] = value;
			this.$set(this.value, fieldName, value);
			this.$emit('input', this.value);
		},
		async gifted(value) {
			this.$store.commit('CHECKOUT_STORE/TOGGLE_PAGE_SPINNER');
			value = !value;
			const $data = {
				action: 'GIFT',
				gift: value,
			};
			await this.$store.dispatch('CART_STORE/UPDATE_CART_ACTION', $data);
			this.$store.commit('CHECKOUT_STORE/TOGGLE_PAGE_SPINNER');
			this.updateMessage(value);
		},
		accepted(value) {
			if (value) value = false;
			else value = true;
			this.updateForm('accepted', value);
		},
		acceptedCheck(value) {
			if (value) value = false;
			else value = true;
			this.updateForm('acceptedUK', value);
			this.$store.commit('USER_STORE/SET_TERMS_VALUE');
		},
		acceptedCheckNews(value) {
			if (value) value = false;
			else value = true;
			this.updateForm('acceptedNewsUK', value);
			this.$store.commit('USER_STORE/SET_SUBSCRIBE_VALUE');
		},
		updateMessage(value) {
			this.comma = value ? ' and' : ',';
		},
		checkUserIfExists(email) {
			const regex = /^\w+([\+.-]?\w+)*@\w+([\.-]?\w+)*(\.\w{2,3})+$/; // eslint-disable-line
			const isValidEmail = regex.test(email);

			if (!isValidEmail || this.showLogin) {
				return;
			}
			this.checkingStatus = false;
			clearTimeout(this.timer);
			this.timer = setTimeout(async () => {
				this.checkingStatus = true;
				this.isUserExists = await this.$store.dispatch('USER_STORE/USER_EXISTENCE_CHECK', { email, source: 'D2C_WEB' });
				this.checkingStatus = false;
			}, this.waitInterval);
		},
		userAction() {
			this.showLogin = !this.showLogin;
			if (!this.showLogin) {
				this.formData.email = '';
				this.formData.password = '';
				this.warning = false;
			}
			const emptyValue = '';
			this.$store.dispatch('USER_STORE/EXIST_USER_ALERT');
			this.updateForm('password', emptyValue);
			this.updateForm('email', emptyValue);
			this.$refs.email_info_validation_observer.reset();
		},
	},
};
</script>
